"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  merge: () => import_merge_anything.merge,
  mergeWith: () => mergeWith
});
module.exports = __toCommonJS(src_exports);
var import_merge_anything = require("merge-anything");
function isFunction(value) {
  return typeof value === "function";
}
function mergeFn(origin, override) {
  if (isFunction(origin) || isFunction(override)) {
    return (...args) => {
      const originValue = isFunction(origin) ? origin(...args) : origin;
      const overrideValue = isFunction(override) ? override(...args) : override;
      return (0, import_merge_anything.mergeAndCompare)(mergeFn, {}, originValue, overrideValue);
    };
  }
  if (Array.isArray(origin) || Array.isArray(override)) {
    return (origin ?? []).concat(override ?? []);
  }
  return override;
}
function mergeWith(...overrides) {
  return (0, import_merge_anything.mergeAndCompare)(mergeFn, {}, ...overrides);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  merge,
  mergeWith
});
